/*
 *  sample_triangle_external_field_2.cpp
 *  
 *
 *  Created by Damian Farnell on 11/04/2008.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

double usr_angle(int bonds, int term13, double *alpha, int numalpha)
{
  // add your model specifique parameter here! 
  //  tdelta * H1 + H2 + H3 + ...
  // model state 2 for triangle and kagome lattices in external fields. (high field limit).
  // now for the q=0 kagome state also.

  double returnValue;
  returnValue=0.0;

  if (bonds == 1) {
	  
    // external field term in H on sites 2 and 3
	  
    if (term13==10) returnValue=      sin(alpha[0]);
    if (term13==11) returnValue= -0.5*cos(alpha[0]);
    if (term13==13) returnValue= -0.5*cos(alpha[0]);

  } else if (bonds == 2) {
	
    // external field term in H on site 1

    if (term13==10) returnValue=      sin(alpha[1]);
    if (term13==11) returnValue= -0.5*cos(alpha[1]);
    if (term13==13) returnValue= -0.5*cos(alpha[1]);
	
  } else if (bonds == 3) {

    // nearest-neighbour bonds in H between sites 1->2 and 3->1 (directional)

    if (term13==1) returnValue=      cos(alpha[0]-alpha[1]);
    if (term13==2) returnValue=  0.5*sin(alpha[0]-alpha[1]);
    if (term13==3) returnValue=  0.5*sin(alpha[0]-alpha[1]);
    if (term13==4) returnValue= -0.5*sin(alpha[0]-alpha[1]);
    if (term13==5) returnValue= -0.5*sin(alpha[0]-alpha[1]);
    if (term13==6) returnValue= 0.25*( 1.0+cos(alpha[0]-alpha[1]));
    if (term13==7) returnValue= 0.25*( 1.0+cos(alpha[0]-alpha[1]));
    if (term13==8) returnValue= 0.25*(-1.0+cos(alpha[0]-alpha[1]));
    if (term13==9) returnValue= 0.25*(-1.0+cos(alpha[0]-alpha[1]));
	  
  } else if (bonds == 4) {
	
    // nearest-neighbour bonds in H between sites 2->3 (directional)

    if (term13==1) returnValue= 0.5;
    if (term13==6) returnValue= 0.25;
    if (term13==7) returnValue= 0.25;

  } 
	
  return returnValue;
}


/*
 *  sample_triangle_external_field_expectation_2.cpp
 *  
 *
 *  Created by Damian Farnell on 11/04/2008.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

double usr_exp_angle(int bonds, int term13, double *alpha, int numalpha)
{
   // add your model specifique parameter here! 
   //  tdelta * H1 + H2 + H3 + ...
   // model state 2 for triangle and kagome lattices in external fields. (high field limit).
   // now for the q=0 kagome state also.
   double returnValue;
   returnValue=0.0;
   if (bonds == 1) {
      // external field term in H on sites 2 and 3
      if (term13==10) returnValue=     sin(alpha[0]);
      if (term13==11) returnValue=-0.5*cos(alpha[0]);
      if (term13==13) returnValue=-0.5*cos(alpha[0]);
   } else if (bonds == 2) {
      // external field term in H on site 1
      if (term13==10) returnValue=     sin(alpha[1]);
      if (term13==11) returnValue=-0.5*cos(alpha[1]);
      if (term13==13) returnValue=-0.5*cos(alpha[1]);
   } 
   return returnValue;
}
